
CoCoALib - Feature #1212

New function: GBasisByHomog

05 Aug 2018 16:41 - Anna Maria Bigatti

Status: Closed Start date: 05 Aug 2018

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: New Function Estimated time: 8.00 hours

Target version: CoCoALib-0.99850 Spent time: 7.70 hours

Description

Implement GBasis computation via homogenization

Related issues:

Related to CoCoALib - Slug #1105: Primary Decompositon (zero-dim)  slow cases Closed 02 Oct 2017

Related to CoCoALib - Feature #1094: Revive code for SelfSaturating GBasis In Progress 09 Aug 2017

Related to CoCoA-5 - Slug #1114: Some other examples for 0-dim radical Closed 31 Oct 2017

Related to CoCoA-5 - Bug #1230: PrimaryDecomposition with lex ordering Closed 19 Oct 2018

Related to CoCoALib - Bug #1379: Fails to recognize zero-dim ideal Closed 27 Dec 2019

Related to CoCoALib - Bug #1423: Radical 0-dim NYI?  missing case for GBasisB... Closed 25 Feb 2020

Related to CoCoALib - Feature #1434: GBasisByHomog for DegLex Closed 04 Mar 2020

History

#1 - 05 Aug 2018 16:41 - Anna Maria Bigatti

- Related to Slug #1105: Primary Decompositon (zero-dim)  slow cases added

#2 - 05 Aug 2018 16:42 - Anna Maria Bigatti

- Related to Feature #1094: Revive code for SelfSaturating GBasis added

#3 - 05 Aug 2018 18:21 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99600 to CoCoALib-0.99650 November 2019

Implemented for the case ordering is StdDegRevLex (SparsePolyOps-ideal.C).

This is enough for PrimaryDecomposition slug #1105.

General case postponed.

#4 - 05 Aug 2018 18:21 - Anna Maria Bigatti

- % Done changed from 10 to 60

#5 - 06 Aug 2018 16:08 - Anna Maria Bigatti

- Subject changed from New function: GBasisViaHomog to New function: GBasisByHomog

#6 - 06 Aug 2018 16:08 - Anna Maria Bigatti

- Related to Slug #1114: Some other examples for 0-dim radical added

#7 - 22 Oct 2018 16:04 - Anna Maria Bigatti

- Related to Bug #1230: PrimaryDecomposition with lex ordering added

#8 - 01 Oct 2019 12:11 - John Abbott
- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-0.99700

#9 - 27 Dec 2019 16:44 - Anna Maria Bigatti

- Related to Bug #1379: Fails to recognize zero-dim ideal added

#10 - 27 Dec 2019 16:48 - Anna Maria Bigatti

I had implemented a trick which I believed would be enough for interreducing (compute the GB twice).

But it is not (see #1379): indeed it is not even minimal (with lex).

Use QQ[x,y,z], Lex;

I := ideal(y*z -2*z^5 -2*z^4 +2*z^3,  y^2 -16*z^5 -12*z^4 +12*z^3 +12*z^2,  x*y -2*x*z -5*y +6*z^5 +2*z^3 -8*z

^2 +10*z,  x^2 +10*x*z -10*x -51*z^5 +74*z^4 +16*z^3 -14*z^2 -50*z +25,  x*z^2 -x*z +5*z^5 -6*z^4 -4*z^3 +5*z,

  z^6 -z^5 -z^4 +z^2,  z^3 -z -1);

GBasisByHomog(I);

-->  [y -4*z -2,  x -z^2,  x*z -z -1,  x^2 -z^2 -z,  z^3 -z -1]

#11 - 27 Dec 2019 18:49 - Anna Maria Bigatti

The trick didn't work ... they usually don't.

Fixed interreduction

#12 - 27 Dec 2019 19:20 - Anna Maria Bigatti

checked-in.  Made new pre-release for Mac.

#13 - 27 Dec 2019 19:21 - Anna Maria Bigatti

- Estimated time changed from 5.00 h to 8.00 h

#14 - 13 Jan 2020 18:23 - Anna Maria Bigatti

This works fine now, but only for few orderings.

The general case will not be done for this release.  Postponing.

#15 - 13 Jan 2020 18:24 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99700 to CoCoALib-0.99800

#16 - 25 Feb 2020 18:27 - Anna Maria Bigatti

- Related to Bug #1423: Radical 0-dim NYI?  missing case for GBasisByHomog added

#17 - 25 Feb 2020 18:28 - Anna Maria Bigatti

Urgent: DegLex (should be easy)

#18 - 04 Mar 2020 19:36 - Anna Maria Bigatti

- Related to Feature #1434: GBasisByHomog for DegLex added

#19 - 07 Mar 2020 08:51 - Anna Maria Bigatti

- % Done changed from 60 to 70
Notes for me.  In general: M matrix ordering.

If first row of M all positive

m m m 1

M   0

otherwise

1 1 1 1

1 1 1 0

M   0

and then call MakeTermOrd so make it square

#20 - 04 Feb 2022 22:22 - John Abbott

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

#21 - 22 Mar 2024 14:32 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 70 to 100

Good thing I wrote #1212-19!  My first implementation was wrong (embarrassing).

Now all implemented and I added a CoCoA-5 test: test-GB.cocoa5
